<?php

namespace app\home\controller;

use core\basic\Controller;

const API_KEY = "bimuapp"; //自己修改这个密码

define('PLUGIN_ATTACH_CACHE_DIR', getcwd().'/data/bimu_cache');
define('UPLOAD_DIR', getcwd().'/static/upload/image' );

use app\api\model\CmsModel;
use app\admin\model\content\ContentModel;

use app\admin\model\content\SiteModel;

class BimuController extends Controller
{

    protected $parser;

    protected $model;

    protected $htmldir;

    public function __construct()
    {

        $this->cmsmodel = new CmsModel();
        $this->contentmodel = new ContentModel();
        
    }

    // 
    public function index()
    {
        $action = isset($_POST['action']) ? $_POST['action'] : null;
        $api_key = isset($_POST['api_key']) ? $_POST['api_key'] : null;

		$result_data = array('status' => 0, 'msg'=> 'ok', 'data' => array());

        header('Content-type:text/json;charset=utf-8');
      
        if($api_key != API_KEY){

            $result_data['status'] = -1;
            $result_data['msg'] = '密钥出错';

            echo json_encode($result_data);
            exit();
        }

		$allow_action = array('api_info', 'category', 'category_ext', 'field', 'attach', 'data');


		if(empty($action) || !in_array($action , $allow_action)) {

			$result_data['status'] = -2;
            $result_data['msg'] = '接口出错';

            echo json_encode($result_data);
            exit();
		}

        $result_data = $this->$action();

        echo json_encode($result_data);
        exit();

    }

    private function api_info(){

        $result_data = array('status' => 0, 'msg'=> 'ok', 'data' => array());
	
        $res = @mkdir(PLUGIN_ATTACH_CACHE_DIR, 0777);

        $system['cms_type'] = 'typecho';
        $system['cms_vertion'] = '1.0';
        $system['api_version'] = '1.0';
        $system['charset'] = 'utf-8';
        $result_data['data'] = $system;


        return $result_data;


    }


    private function category(){

        $result_data = array('status' => 0, 'msg'=> 'ok', 'data' => array());
	
        $acode = 'cn';
        $data = (array)$this->cmsmodel->getSorts($acode);
        $category_data = array();
        foreach ($data as $v) {

            if($v->mcode != 2) continue;

            foreach ($v->son as $v2) {
                $row = (array)$v2;
                $category_data[] = array('id' => $row['id'], 'name' => $row['name'], 'parent_id' => 0, 'disabled' =>  0);
            }

        }

        $result_data['data']['category_data'] = $category_data;
		$result_data['data']['multiselect'] = 0;//是否多选

        return $result_data;


    }



    public function field(){
	
    
        $result_data = array();
    
        $result_data['status'] = 0;
        $result_data['msg'] = 'ok';
        $result_data['data'] = array();
    
    
        $tpl_data = array(
    
            'title' => array(
                'key' => 'title',
                'name' => '标题',
            ),
            'content' => array(
                'key' => 'content',
                'name' => '内容',
            ),
            
        );
    
    
        $data['bind'] = $tpl_data;
    
        $result_data['data'] = $data;
    
    
        return $result_data;

    }



    public function attach(){
	
    
        $result_data = array('status' => 0, 'msg'=> 'ok', 'data' => '');


        $content = isset($_POST['content']) ? $_POST['content'] : null;
        
        $content = base64_decode(str_replace(" ", "+", $content));

        $data_id = $_POST['data_id'];
        $_id = $_POST['_id'];
        $data = $_POST['data'];

        $data = json_decode($data, true);

        $fpath = $this->_get_attach_save_path($data['data_id'], $data['_id']);


        $fp = fopen($fpath, "w");

        fwrite($fp, $content);

        return $result_data;

    }


    public function data(){
	
    
        $result_data = array('status' => 0, 'msg'=> 'ok', 'data' => '');


        $result_data = array('status' => 0, 'msg'=> 'ok', 'data' => array());
	
        $post_data = isset($_POST['data']) ? $_POST['data'] : null;

        $post_data = json_decode($post_data, true);


        $data_id = isset($post_data['data_id']) ? $post_data['data_id'] : '';

        $title = $post_data['field_data']['title'];
        $content = $post_data['field_data']['content'];


        $cid = $post_data['cat_data']['cid'];


        $imagereplace = array(
            'search' => array(),
            'replace' => array(),
        );

        $attachreplace = array(
            'search' => array(),
            'replace' => array(),
        );

        $cover_pic_url = '';
    
        $ico = '';

        //读取附件
        foreach((array)$post_data['attach_data'] as $key1 => $value1){

            foreach($value1 as $key2 => $value2){


                $real_path = $this->_get_attach_save_path($post_data['_id'], $value2['_id']);      

                if($value2['isimage'] == 1){

                    $imagereplace['search'][$key2] = $value2['ref'];

                    if($value2['download_status'] == 1){

                        $imge_real_url = $this->create_attach($value2, $real_path);

                        if(!$ico) $ico = $imge_real_url;

                        $imagereplace['replace'][$key2] = '<img src="'.$imge_real_url.'" />';
    
                    }else{

                        if(!$cover_pic_url){
                            $cover_pic_url = $value2['src'];
                        }

                        $imagereplace['replace'][$key2] = '<img src="'.$value2['src'].'" />';
                    }

                }else{

                    $attachreplace['search'][$key2] = $value2['ref'];
                    $attachreplace['replace'][$key2] = '<a target="_blank" href="'.$value2['src'].'" >'.$value2['text'].'</a>';


                }
            }

        }



        $content = str_replace($imagereplace['search'], $imagereplace['replace'], $content);
        $content = str_replace($attachreplace['search'], $attachreplace['replace'], $content);

        $public_time = $post_data['field_ext']['public_time'];

        $sort_data = $this->cmsmodel->getSorts('cn', 2);

        $found_key = array_search(2, array_column($sort_data, 'scode'));

        $find_sort_data = $sort_data[$found_key];

        $found_key = array_search($cid, array_column((array)$find_sort_data->son, 'id'));

        $sort_find_data = (array)$find_sort_data->son[$found_key];
        

        // 获取数据
        $scode = $sort_find_data['scode'];
        $acode = $sort_find_data['acode'];

        $subscode = '';

        $title = $title;
        $titlecolor = '#333333';
        $subtitle = post('subtitle');
        $filename = '';
        $author = '超级管理员';
        $source = '本站';
        $outlink = '';
        $date = date('Y-m-d H:i:s', $public_time);
        $pics = '';
        
        // 获取多图标题
        $picstitle = '';

        $tags_input = $post_data['field_ext']['tags'];
    	if($tags_input && is_array($tags_input)) $tags_input = implode(',', $tags_input);
     
        $tags = $tags_input;
        $enclosure = '';
        $keywords = '';
        $description = '';
        $status = 1;
        $istop = 0;
        $isrecommend = 0;
        $isheadline = 0;
        
        $gid = 0;
        $gtype = 4;
        $gnote = 0;
        

        // 构建数据
        $data = array(
            'acode' => $acode,
            'scode' => $scode,
            'subscode' => $subscode,
            'title' => $title,
            'titlecolor' => $titlecolor,
            'subtitle' => $subtitle,
            'filename' => $filename,
            'author' => $author,
            'source' => $source,
            'outlink' => $outlink,
            'date' => $date,
            'ico' => $ico,
            'pics' => $pics,
            'picstitle' => $picstitle,
            'content' => $content,
            'tags' => $tags,
            'enclosure' => $enclosure,
            'keywords' => $keywords,
            'description' => clear_html_blank($description),
            'sorting' => 255,
            'status' => $status,
            'istop' => $istop,
            'isrecommend' => $isrecommend,
            'isheadline' => $isheadline,
            'gid' => $gid,
            'gtype' => $gtype,
            'gnote' => $gnote,
            'visits' => 0,
            'likes' => 0,
            'oppose' => 0,
            'create_user' => 'admin',
            'update_user' => 'admin',
        );

        

        $id = $this->contentmodel->addContent($data);

        

        if (isset($_SERVER["HTTPS"]) && strtolower($_SERVER["HTTPS"]) == "on") {
			$http = "https://";
		} else {
			$http =  "http://";
		}

        $domain = $http.str_replace('\\', '/', $_SERVER['HTTP_HOST']);


        $result_data['data']['data_id'] = $id;
        $result_data['data']['data_url'] = $domain.$_SERVER['SCRIPT_NAME'].'?'.$sort_find_data['filename'].'/'.$id.'.html';


        return $result_data;

    }

    private function create_attach($attach_info, $real_path){


        $fcontent = @file_get_contents($real_path);
			
        $dir = UPLOAD_DIR.'/'.date('Ymd', time());

        $res = @mkdir(dir, 0777);

        $path = $dir .'/'.$attach_info['_id'].'.'.$attach_info['ext'];


        $path_arr = explode(getcwd(), $path);

		$fp = fopen($path, "w");

		fwrite($fp, $fcontent);


        $rootUrl= dirname(getcwd());
        $arr = explode( $rootUrl.'/', getcwd());

        return '/'.$arr[1].$path_arr[1];



    }

    private function _get_attach_save_path($data_id, $attach_id){
	
        $res = @mkdir(PLUGIN_ATTACH_CACHE_DIR, 0777);

        $dir = PLUGIN_ATTACH_CACHE_DIR.'/'.$data_id.'';

        $res = @mkdir($dir, 0777);
    
        $fpath = $dir.'/'.$attach_id;
    
        return $fpath;
    
    }


}